/* MailTweak internal component - Copyright (C) 2007 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://journal.mozdev.org/mailtweak.html */
tweaks = [
"accselect","addrlines","bccdefault","columnlock","compact","configdata","dialogmenu","disconnect","dontsave","extoptions","focusfix","folderhide","foldericon","foldermenu","images","insertmenu","keepcopy","localhide","nosubject","permapen","personal","statusicon","statuslog","tagnumber","treefont","wordcount"
]
APP = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime)
elem = function (id) {return document.getElementById(id)}
pref = {
__proto__: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extension.mailtweak."),getUniCharPref: function (p) {
var s = this.getComplexValue(p, Components.interfaces.nsISupportsString)
return s.toString()},setUniCharPref: function (p, v) {
var s = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString)
s.data = v
this.setComplexValue(p, Components.interfaces.nsISupportsString, s)}}
accept = function () {
var m = false, a = false, c = false
if (elem("reload").checked)
for each (var t in tweaks) if (this[t].changed)
m = m || this[t].reloadMail,a = a || this[t].reloadAB,c = c || this[t].reloadComp
for each (var t in tweaks) this[t].save()
if (m || a || c) MailTweakService.reload(m, a, c)}
changes = function () {
var rl = false, ok = false
for each (var t in tweaks) {
var c = this[t].changed
if (c) rl = rl || this[t].reload
ok = ok || c}
with (elem("reload")) {
disabled = !ok || !rl
if (disabled) checked = false}
document.documentElement.getButton("accept").disabled = !ok}
enable = function (parent, ok) {
if (!parent.localName) return
switch (parent.localName) {
case "vbox":
case "hbox":
case "description":
case "grid":
case "columns":
case "column":
case "rows":
case "row":
break;
default: parent[ok? "removeAttribute":"setAttribute"]("disabled", "true")}
var e = parent.firstChild
while (e) enable(e, ok), e = e.nextSibling}
listClick = function (event) {
var tgt = event.originalTarget
if (event.screenX
&& tgt.localName == "listitem"
&& event.screenX >= document.getAnonymousNodes(
document.getAnonymousNodes(tgt)[0])
[1].boxObject.screenX)
event.stopPropagation()
else setTimeout(listSelect, 0)}
listKey = function (event) {
if (event.charCode == 32) setTimeout(changes, 0)}
currentPanel = null
listSelect = function (event) {
var listitem = elem("tweak-list").selectedItem
var tweakid = listitem.id.replace(/urn:mailtweak:/, "")
var panel = elem(tweakid)
if (currentPanel) panelAccess(currentPanel, false)
panelAccess(panel, true)
currentPanel = panel
elem("item-caption").setAttribute("label", listitem.label)
elem("item-deck").selectedPanel = panel
enable(panel, listitem.checked)
this[tweakid].ui()
changes()}
panelAccess = function (node, ok) {
var c = node.firstChild
if (!c || !c.localName) return
while (c) {
if (ok) {
if (c.hasAttribute("keywas"))
c.setAttribute("accesskey", c.getAttribute("keywas"))}
else {
if (c.hasAttribute("accesskey"))
c.setAttribute("keywas", c.getAttribute("accesskey")), c.removeAttribute("accesskey")}
panelAccess(c, ok)
c = c.nextSibling}}
onload = function () {
var os = APP.OS.toUpperCase().substr(0, 3)
if (os != "WIN" && os != "OS2")
document.title = document.documentElement.getAttribute("titleprefs")
const RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService)
const RCU = Components.classes["@mozilla.org/rdf/container-utils;1"].getService(Components.interfaces.nsIRDFContainerUtils)
var ds = Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"].createInstance(Components.interfaces.nsIRDFDataSource)
var seq = RCU.MakeSeq(ds, RDF.GetResource("urn:mailtweak:root"))
const label = RDF.GetResource("mailtweak#label")
var panel = elem("item-deck").firstChild
while (panel) {
var res = RDF.GetResource("urn:mailtweak:" + panel.id)
ds.Assert(res, label, RDF.GetLiteral(panel.getAttribute("label")), true)
seq.AppendElement(res)
panelAccess(panel, false)
panel = panel.nextSibling}
var list = elem("tweak-list")
with (list) database.AddDataSource(ds), builder.rebuild()
try {Components.classes["@mozilla.org/messenger/tagservice;1"].getService(Components.interfaces.nsIMsgTagService)}
catch (ex) {
with (elem("tagnumber")) checked = false, disabled = true}
for each (var t in tweaks) this[t].init()
with (list)
addEventListener("mousedown", function (event) {listClick(event)}, true),selectedIndex = 0,focus()
addEventListener("keypress", function (event) {pageKey(event)}, false)}
pageKey = function (event) {
if (event.keyCode != event.DOM_VK_PAGE_UP
&& event.keyCode != event.DOM_VK_PAGE_DOWN) return
var list = elem("tweak-list")
if (event.target == list) return
var i = list.selectedIndex
+ (event.keyCode == event.DOM_VK_PAGE_UP? -1:1)
if (i < 0 || i > list.getRowCount()) return
list.selectedIndex = i
list.ensureIndexIsVisible(i)
listSelect()}
scrollKey = function (event) {
var bar = event.target
var now = Number(bar.getAttribute("curpos"))
switch (event.keyCode) {
case event.DOM_VK_LEFT:
case event.DOM_VK_DOWN:
if (now > 0) bar.setAttribute("curpos", now - Number(bar.getAttribute("increment")))
break;
case event.DOM_VK_RIGHT:
case event.DOM_VK_UP:
if (now < Number(bar.getAttribute("maxpos")))
bar.setAttribute("curpos", now + Number(bar.getAttribute("increment")))
break;
case event.DOM_VK_HOME:
bar.setAttribute("curpos", 0)
break;
case event.DOM_VK_END:
bar.setAttribute("curpos", bar.getAttribute("maxpos"))
break;}
changes()}
Tweak = {
id: "",reloadMail: false,reloadAB: false,reloadComp: false,get active () {return this._checkbox.checked},get changed () {return this._checkbox.checked != this._waschecked},get reload () {return this.reloadMail || this.reloadAB || this.reloadComp},init: function () {
this._checkbox = elem("urn:mailtweak:" + this.id)
var ok = pref.getBoolPref(this.id)
this._checkbox.checked = ok
this._waschecked = ok},save: function () {pref.setBoolPref(this.id, this._checkbox.checked)},ui: function () {}}
accselect = {
__proto__: Tweak,id: "accselect"}
addrlines = {
__proto__: Tweak,id: "addrlines",reloadComp: true,get changed () {
var r = this._checkbox.checked != this._waschecked
|| this._lines.value != pref.getIntPref("addrlines.lines")
return r},init: function () {
Tweak.init.call(this)
this._lines = elem("addrlines-lines")
this._lines.value = pref.getIntPref("addrlines.lines")},save: function () {
Tweak.save.call(this)
pref.setIntPref("addrlines.lines", this._lines.value)}}
bccdefault = {
__proto__: Tweak,id: "bccdefault",reloadComp: true}
columnlock = {
__proto__: Tweak,id: "columnlock",reloadMail: true,reloadAB: true}
compact = {
__proto__: Tweak,id: "compact",reloadMail: true}
configdata = {
__proto__: Tweak,id: "configdata",reloadMail: true}
dialogmenu = {
__proto__: Tweak,id: "dialogmenu",reloadMail: true}
disconnect = {
__proto__: Tweak,id: "disconnect",reloadMail: true,get changed () {
return this._checkbox.checked != this._waschecked
|| this._delay.value != pref.getIntPref("disconnect.delay")
|| this._script.value != pref.getCharPref("disconnect.script")
|| this._offline.checked != pref.getBoolPref("disconnect.offline")},init: function () {
Tweak.init.call(this)
this._delay = elem("disconnect-delay")
this._script = elem("disconnect-script")
this._offline = elem("disconnect-offline")
this._delay.value = pref.getIntPref("disconnect.delay")
this._script.value = pref.getCharPref("disconnect.script")
this._offline.checked = pref.getBoolPref("disconnect.offline")},save: function () {
Tweak.save.call(this)
pref.setIntPref("disconnect.delay", this._delay.value || 0)
pref.setCharPref("disconnect.script", this._script.value)
pref.setBoolPref("disconnect.offline", this._offline.checked)}}
dontsave = {
__proto__: Tweak,id: "dontsave",reloadComp: true}
extoptions = {
__proto__: Tweak,id: "extoptions",}
focusfix = {
__proto__: Tweak,id: "focusfix",reloadComp: true}
folderhide = {
__proto__: Tweak,id: "folderhide",reloadMail: true}
foldericon = {
__proto__: Tweak,id: "foldericon",reloadMail: true}
foldermenu = {
__proto__: Tweak,id: "foldermenu",reloadMail: true,get changed () {
return this._checkbox.checked != this._waschecked
|| this._favorite.checked != pref.getBoolPref("foldermenu.favorite")
|| this._recent.checked != pref.getBoolPref("foldermenu.recent")},init: function () {
Tweak.init.call(this)
this._favorite = elem("foldermenu-favorite")
this._recent = elem("foldermenu-recent")
this._favorite.checked = pref.getBoolPref("foldermenu.favorite")
this._recent.checked = pref.getBoolPref("foldermenu.recent")},save: function () {
Tweak.save.call(this)
pref.setBoolPref("foldermenu.favorite", this._favorite.checked)
pref.setBoolPref("foldermenu.recent", this._recent.checked)}}
images = {
__proto__: Tweak,id: "images",reloadComp: true,get changed () {
return this._checkbox.checked != this._waschecked
|| this._attach.checked != pref.getBoolPref("images.attach")
|| this._alttext.checked != pref.getBoolPref("images.alttext")
|| this._text.value != pref.getUniCharPref("images.text")},init: function () {
Tweak.init.call(this)
this._attach = elem("images-attach")
this._alttext = elem("images-alttext")
this._text = elem("images-text")
this._attach.checked = pref.getBoolPref("images.attach")
this._alttext.checked = pref.getBoolPref("images.alttext")
with (this._text)
value = pref.getUniCharPref("images.text"), setAttribute("was", value)},save: function () {
Tweak.save.call(this)
pref.setBoolPref("images.attach", this._attach.checked)
pref.setBoolPref("images.alttext", this._alttext.checked)
pref.setUniCharPref("images.text", this._text.value)},ui: function () {
var ok = this._alttext.checked
with (this._text) {
disabled = !ok
if (ok) value = getAttribute("was") || getAttribute("fallback")
else setAttribute("was", value), value = ""}}}
insertmenu = {
__proto__: Tweak,id: "insertmenu",reloadComp: true,}
keepcopy = {
__proto__: Tweak,id: "keepcopy",reloadComp: true,get changed () {
return this._checkbox.checked != this._waschecked
|| this._noprompt.checked != pref.getBoolPref("keepcopy.noprompt")},init: function () {
Tweak.init.call(this)
this._noprompt = elem("keepcopy-noprompt")
this._noprompt.checked = pref.getBoolPref("keepcopy.noprompt")},save: function () {
Tweak.save.call(this)
pref.setBoolPref("keepcopy.noprompt", this._noprompt.checked)}}
localhide = {
__proto__: Tweak,id: "localhide",reloadMail: true}
nosubject = {
__proto__: Tweak,id: "nosubject",reloadComp: true,get changed () {
return this._checkbox.checked != this._waschecked
|| this._text.value != pref.getUniCharPref("nosubject.text")},init: function () {
Tweak.init.call(this)
this._text = elem("nosubject-text")
with (this._text) {
if (pref.prefHasUserValue("nosubject.text"))
value = pref.getUniCharPref("nosubject.text")
else pref.setUniCharPref("nosubject.text", value)
setAttribute("was", value)}},save: function () {
Tweak.save.call(this)
pref.setUniCharPref("nosubject.text", this._text.value)}}
personal = {
__proto__: Tweak,id: "personal",reloadMail: true,reloadAB: true,reloadComp: true,get changed () {return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked && (
elem("personal-marker").value != pref.getCharPref("personal.marker")
|| elem("personal-uniqueid").checked != pref.getBoolPref("personal.uniqueid")))},init: function () {
Tweak.init.call(this)
this._marker = elem("personal-marker")
this._marker.value = pref.getCharPref("personal.marker")
this._example = elem("personal-example").firstChild
this.showExample(true)
this._uniqueid = elem("personal-uniqueid")
this._uniqueid.checked = pref.getBoolPref("personal.uniqueid")},showExample: function (normalize) {
var m = this._marker.value.replace(/\s/g, "")
if (m == "") m = "%%"
if (normalize) this._marker.value = m
this._example.nodeValue = m + "firstName" + m},save: function () {
Tweak.save.call(this)
pref.setCharPref("personal.marker", this._marker.value)
pref.setBoolPref("personal.uniqueid", this._uniqueid.checked)}}
permapen = {
__proto__: Tweak,id: "permapen",reloadComp: true,_platform: null,get changed () {return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked && (
elem("permapen-face").value != pref.getCharPref("permapen.face")
|| elem("permapen-size").value != pref.getIntPref("permapen.size")
|| elem("permapen-color").color != pref.getCharPref("permapen.color")
|| elem("permapen-ground").color != pref.getCharPref("permapen.ground")
|| elem("permapen-bold").checked != pref.getBoolPref("permapen.bold")
|| elem("permapen-italic").checked != pref.getBoolPref("permapen.italic")
|| elem("permapen-underline").checked != pref.getBoolPref("permapen.underline")
|| elem("permapen-key").getAttribute("keyspec") != pref.getCharPref("permapen.key")))},init: function () {
Tweak.init.call(this)
var flist = elem("permapen-face")
try {
var ff = Components.classes["@mozilla.org/gfx/fontenumerator;1"].getService(Components.interfaces.nsIFontEnumerator).EnumerateAllFonts({})
for each (var f in ff) if (f) flist.appendItem(f, f)} catch (ex) {}
flist.value = pref.getCharPref("permapen.face")
elem("permapen-size").value = pref.getIntPref("permapen.size")
elem("permapen-color").color = pref.getCharPref("permapen.color")
elem("permapen-ground").color = pref.getCharPref("permapen.ground")
elem("permapen-bold").checked = pref.getBoolPref("permapen.bold")
elem("permapen-italic").checked = pref.getBoolPref("permapen.italic")
elem("permapen-underline").checked = pref.getBoolPref("permapen.underline")
elem("permapen-key").setAttribute("keyspec", pref.getCharPref("permapen.key"))
this._platform = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://global-platform/locale/platformKeys.properties")
this.keyDisplay()},key: function (event) {
if (event.keyCode == 9) return
var k = []
if (event.ctrlKey) k.push("control")
if (event.altKey) k.push("alt")
if (event.metaKey) k.push("meta")
if (event.shiftKey) k.push("shift")
var ok = false
if (event.charCode) {
ok = k.length > 0
if (ok) k.push(String.fromCharCode(event.charCode).toUpperCase())}
else {
for (e in event) {
if (e.indexOf("DOM_") == 0 && event[e] == event.keyCode) {
k.push(e.substr(4))
ok = true
break}}}
if (ok) {
event.target.setAttribute("keyspec", k.join(" "))
this.keyDisplay()
changes()}
event.preventDefault()},keyDisplay: function () {
var textbox = elem("permapen-key")
var k = textbox.getAttribute("keyspec").split(" ")
var t = [], key = k.pop().replace(/VK_/, "")
for each (var e in k)
t.push(this._platform.GetStringFromName("VK_" + e.toUpperCase()))
t.push(key)
textbox.value = t.join(this._platform.GetStringFromName("MODIFIER_SEPARATOR"))},save: function () {
Tweak.save.call(this)
pref.setCharPref("permapen.key", elem("permapen-key").getAttribute("keyspec"))
pref.setCharPref("permapen.face", elem("permapen-face").value)
pref.setIntPref("permapen.size", elem("permapen-size").value)
pref.setCharPref("permapen.color", elem("permapen-color").color)
pref.setCharPref("permapen.ground", elem("permapen-ground").color)
pref.setBoolPref("permapen.bold", elem("permapen-bold").checked)
pref.setBoolPref("permapen.italic", elem("permapen-italic").checked)
pref.setBoolPref("permapen.underline", elem("permapen-underline").checked)}}
statusicon = {
__proto__: Tweak,id: "statusicon"}
statuslog = {
__proto__: Tweak,id: "statuslog",reloadMail: true,get changed () {
return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked && (
elem("statuslog-display").value != pref.getIntPref("statuslog.display")
|| elem("statuslog-type").selectedIndex != pref.getIntPref("statuslog.type")
|| elem("statuslog-limit").value != pref.getIntPref("statuslog.limit")))},init: function () {
Tweak.init.call(this)
elem("statuslog-display").value = pref.getIntPref("statuslog.display")
elem("statuslog-type").selectedIndex = pref.getIntPref("statuslog.type")
elem("statuslog-limit").value = pref.getIntPref("statuslog.limit")},save: function () {
Tweak.save.call(this)
pref.setIntPref("statuslog.display", elem("statuslog-display").value)
pref.setIntPref("statuslog.type", elem("statuslog-type").selectedIndex)
pref.setIntPref("statuslog.limit", elem("statuslog-limit").value)},ui: function () {
this._radio = elem("statuslog-type")
var n = elem("statuslog-limit")
switch (this._radio.selectedItem.value) {
case "0": 
n.setAttribute("min", "10")
n.setAttribute("max", "1000")
n.setAttribute("log", "single")
n.setAttribute("step", "1.33")
break
case "1": 
n.setAttribute("min", "5")
n.setAttribute("max", "60")
n.removeAttribute("log")
n.setAttribute("step", "15")
break
case "2": 
n.setAttribute("min", "1")
n.setAttribute("max", "24")
n.setAttribute("log", "whole")
n.setAttribute("step", "2")
break}}}
tagnumber = {
__proto__: Tweak,id: "tagnumber",reloadMail: true,_wait: null,_key: null,get changed () {
return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked
&& elem("tagnumber-delay").getAttribute("curpos") != this._curposwas)},get delay () {
return 200 + Number(elem("tagnumber-delay").getAttribute("curpos")) * 100},init: function () {
Tweak.init.call(this)
this._curposwas = (pref.getIntPref("tagnumber.delay") - 200) / 100
with (elem("tagnumber-delay")) {
setAttribute("curpos", this._curposwas)
addEventListener("DOMAttrModified",function (event) {
if (event.attrName != "curpos" || event.eventPhase != 2) return
changes()},true)}},keyAction: function () {
this._wait = null
elem("tagnumber-test").value = this._key
this._key = 0},test: function (event) {
elem("tagnumber-test").value = ""
event.preventDefault()
if (!event.charCode || event.charCode < event.DOM_VK_0 || event.charCode > event.DOM_VK_9)
return
var k = event.charCode - event.DOM_VK_0, n = 19
if (this._wait) {
clearTimeout(this._wait)
this._wait = null
this._key = this._key * 10 + k
var go = this._key * 10 > n}
else {
this._key = k
var go = k == 0 || k * 10 > n}
if (go) this.keyAction()
else this._wait = setTimeout("tagnumber.keyAction()", this.delay)},save: function () {
Tweak.save.call(this)
pref.setIntPref("tagnumber.delay", this.delay)}}
treefont = {
__proto__: Tweak,id: "treefont",reloadMail: true,reloadAB: true,get changed () {
return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked
&& elem("treefont-size").getAttribute("curpos") != this._curposwas)},init: function () {
Tweak.init.call(this)
var size = pref.getIntPref("treefont.size")
if (size == 0) size = parseInt(document.defaultView.getComputedStyle(elem("treefont-sample"), "").fontSize)
elem("treefont-inbox").style.fontSize = String(size) + "px"
this._curposwas = size - 6
with (elem("treefont-size")) {
setAttribute("curpos", size - 6)
addEventListener("DOMAttrModified",function (event) {
if (event.attrName != "curpos" || event.eventPhase != 2) return
elem("treefont-inbox").style.fontSize = String(Number(event.newValue) + 6) + "px !important"
changes()},true)}},save: function () {
Tweak.save.call(this)
pref.setIntPref("treefont.size",Number(elem("treefont-size").getAttribute("curpos")) + 6)}}
wordcount = {
__proto__: Tweak,id: "wordcount",reloadComp: true}